PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
List of all members
PAbstractSet Class Reference

Abstract set of PObjects. More...

`#include <dict.h>`

Inheritance diagram for PAbstractSet:
[legend]
Collaboration diagram for PAbstractSet:
[legend]

## Public Member Functions
Construction
PINLINE | PAbstractSet ()
| Create a new, empty, set. More...
Public Member Functions inherited from PHashTable
| PHashTable ()
| Create a new, empty, hash table. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two hash tables. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for hash table. More...
PINLINE PBoolean | AbstractContains (const PObject &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual const PObject & | AbstractGetKeyAt (PINDEX index) const
| Get the key in the hash table at the ordinal index position. More...
virtual PObject & | AbstractGetDataAt (PINDEX index) const
| Get the data in the hash table at the ordinal index position. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Overrides from class PCollection
virtual PINDEX | Append (PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Add a new object to the collection. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove an object at the specified index. More...
virtual PObject * | GetAt (PINDEX index) const
| This function is the same as PHashTable::AbstractGetKeyAt(). More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Add a new object to the collection. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
bool | Union (const PAbstractSet &set)
| Calculate union of sets. More...
static bool | Intersection (const PAbstractSet &set1, const PAbstractSet &set2, PAbstractSet *intersection=NULL)
| Calculate intersection of sets. More...

## Additional Inherited Members
Public Types inherited from PHashTable
typedef PHashTableElement | Element
typedef PHashTableInfo | Table
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
Public Attributes inherited from PHashTable
PHashTableInfo * | hashTable
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Attributes inherited from PContainer
PContainerReference * | reference
Friends inherited from PObject

## Detailed Description

Abstract set of PObjects.

## Constructor & Destructor Documentation

PINLINE PAbstractSet::PAbstractSet | ( |  | ) |

Create a new, empty, set.

Note that by default, objects placed into the list will be deleted when removed or when all references to the list are destroyed.

## Member Function Documentation

virtual PINDEX PAbstractSet::Append | ( | PObject * | obj | ) |
| virtual

Add a new object to the collection.

If the objects value is already in the set then the object is not included. If the `AllowDeleteObjects` option is set then the `obj` parameter is also deleted.

Returns
  hash function value of the newly added object.

Parameters

  obj | New object to place into the collection.

Implements PCollection.

Referenced by PSet< PString >::Include(), and PSet< PString >::operator+=().

virtual PObject* PAbstractSet::GetAt | ( | PINDEX | index | ) | const
| virtual

This function is the same as PHashTable::AbstractGetKeyAt().

WARNING: this code requires a linear search for every operation and will be VERY slow for large data sets. This function is kept for backwards compatibilty only. New code should use the iterator based access methods

Returns
  Always NULL.

Parameters

  index | Index position in the collection of the object.

Implements PCollection.

virtual PINDEX PAbstractSet::GetObjectsIndex | ( | const PObject * | obj | ) | const
| virtual

Search the collection for the specific instance of the object.

The object pointers are compared, not the values. The hash table is used to locate the entry.

Note that that will require value comparisons to be made to find the equivalent entry and then a final check is made with the pointers to see if they are the same instance.

Returns
  ordinal index position of the object, or P_MAX_INDEX .

Parameters

  obj | Object to find.

Implements PCollection.

virtual PINDEX PAbstractSet::GetValuesIndex | ( | const PObject & | obj | ) | const
| virtual

Search the collection for the specified value of the object.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

Returns
  ordinal index position of the object, or P_MAX_INDEX.

Parameters

  obj | Object to find equal value.

Implements PCollection.

virtual PINDEX PAbstractSet::Insert | ( | const PObject & | before,
|  | PObject * | obj
| ) |  |
| virtual

Add a new object to the collection.

If the objects value is already in the set then the object is not included. If the `AllowDeleteObjects` option is set then the `obj` parameter is also deleted.

The object is always placed in the an ordinal position dependent on its hash function. It is not placed at the specified position. The `before` parameter is ignored.

Returns
  hash function value of the newly added object.

Parameters

  before | Object value to insert before.
  obj | New object to place into the collection.

Implements PCollection.

virtual PINDEX PAbstractSet::InsertAt | ( | PINDEX | index,
|  | PObject * | obj
| ) |  |
| virtual

Add a new object to the collection.

If the objects value is already in the set then the object is not included. If the `AllowDeleteObjects` option is set then the `obj` parameter is also deleted.

The object is always placed in the an ordinal position dependent on its hash function. It is not placed at the specified position. The `index` parameter is ignored.

Returns
  hash function value of the newly added object.

Parameters

  index | Index position in collection to place the object.
  obj | New object to place into the collection.

Implements PCollection.

static bool PAbstractSet::Intersection | ( | const PAbstractSet & | set1,
|  | const PAbstractSet & | set2,
|  | PAbstractSet * | intersection = `NULL`
| ) |  |
| static

Calculate intersection of sets.

Returns true if there is an intersection.

virtual PBoolean PAbstractSet::Remove | ( | const PObject * | obj | ) |
| virtual

Remove the object from the collection.

If the `AllowDeleteObjects` option is set then the object is also deleted.

Note that the comparison for searching for the object in collection is made by pointer, not by value. Thus the parameter must point to the same instance of the object that is in the collection.

Returns
  true if the object was in the collection.

Parameters

  obj | Existing object to remove from the collection.

Implements PCollection.

Referenced by PSet< PString >::erase(), and PSet< PString >::Exclude().

virtual PObject* PAbstractSet::RemoveAt | ( | PINDEX | index | ) |
| virtual

Remove an object at the specified index.

If the `AllowDeleteObjects` option is set then the object is also deleted.

WARNING: this code requires a linear search for every operation and will be VERY slow for large data sets. This function is kept for backwards compatibilty only. New code should use the iterator based access methods

Returns
  pointer to the object being removed, or NULL if it was deleted.

Parameters

  index | Index position in collection to place the object.

Implements PCollection.

virtual PBoolean PAbstractSet::SetAt | ( | PINDEX | index,
|  | PObject * | val
| ) |  |
| virtual

Add a new object to the collection.

If the objects value is already in the set then the object is not included. If the AllowDeleteObjects option is set then the `obj` parameter is also deleted.

The object is always placed in the an ordinal position dependent on its hash function. It is not placed at the specified position. The `index` parameter is ignored.

Returns
  true if the object was successfully added.

Parameters

  index | Index position in collection to set.
  val | New value to place into the collection.

Implements PCollection.

bool PAbstractSet::Union | ( | const PAbstractSet & | set | ) |

Calculate union of sets.

Returns true if any new elements were added.

The documentation for this class was generated from the following file:

- dict.h